/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
 * This header typedefs the old 'native' types to the new PR<type>s.^M
 * These definitions are scheduled to be eliminated at the earliest^M
 * possible time. The NSPR API is implemented and documented using^M
 * the new definitions.^M
 */^M
^M
#if !defined(PROTYPES_H)^M
#define PROTYPES_H^M
^M
typedef PRUintn uintn;^M
#ifndef _XP_Core_^M
typedef PRIntn intn;^M
#endif^M
^M
/*^M
 * It is trickier to define uint, int8, uint8, int16, uint16,^M
 * int32, uint32, int64, and uint64 because some of these int^M
 * types are defined by standard header files on some platforms.^M
 * Our strategy here is to include all such standard headers^M
 * first, and then define these int types only if they are not^M
 * defined by those standard headers.^M
 */^M
^M
/*^M
 * BeOS defines all the int types below in its standard header^M
 * file SupportDefs.h.^M
 */^M
#ifdef XP_BEOS^M
#include <support/SupportDefs.h>^M
#endif^M
^M
/*^M
 * OpenVMS defines all the int types below in its standard^M
 * header files ints.h and types.h.^M
 */^M
#ifdef VMS^M
#include <ints.h>^M
#include <types.h>^M
#endif^M
^M
/*^M
 * SVR4 typedef of uint is commonly found on UNIX machines.^M
 *^M
 * On AIX 4.3, sys/inttypes.h (which is included by sys/types.h)^M
 * defines the types int8, int16, int32, and int64.^M
 */^M
#ifdef XP_UNIX^M
#include <sys/types.h>^M
#endif^M
^M
/* model.h on HP-UX defines int8, int16, and int32. */^M
#ifdef HPUX^M
#include <model.h>^M
#endif^M
^M
/*^M
 * uint^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS) \^M
    && !defined(XP_UNIX) || defined(NTO)^M
typedef PRUintn uint;^M
#endif^M
^M
/*^M
 * uint64^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS)^M
typedef PRUint64 uint64;^M
#endif^M
^M
/*^M
 * uint32^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS)^M
#if !defined(XP_MAC) && !defined(_WIN32) && !defined(XP_OS2)^M
typedef PRUint32 uint32;^M
#else^M
typedef unsigned long uint32;^M
#endif^M
#endif^M
^M
/*^M
 * uint16^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS)^M
typedef PRUint16 uint16;^M
#endif^M
^M
/*^M
 * uint8^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS)^M
typedef PRUint8 uint8;^M
#endif^M
^M
/*^M
 * int64^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS) \^M
    && !defined(_PR_AIX_HAVE_BSD_INT_TYPES)^M
typedef PRInt64 int64;^M
#endif^M
^M
/*^M
 * int32^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS) \^M
    && !defined(_PR_AIX_HAVE_BSD_INT_TYPES) \^M
    && !defined(HPUX)^M
#if !defined(WIN32) || !defined(_WINSOCK2API_)  /* defines its own "int32" */^M
#if !defined(XP_MAC) && !defined(_WIN32) && !defined(XP_OS2)^M
typedef PRInt32 int32;^M
#else^M
typedef long int32;^M
#endif^M
#endif^M
#endif^M
^M
/*^M
 * int16^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS) \^M
    && !defined(_PR_AIX_HAVE_BSD_INT_TYPES) \^M
    && !defined(HPUX)^M
typedef PRInt16 int16;^M
#endif^M
^M
/*^M
 * int8^M
 */^M
^M
#if !defined(XP_BEOS) && !defined(VMS) \^M
    && !defined(_PR_AIX_HAVE_BSD_INT_TYPES) \^M
    && !defined(HPUX)^M
typedef PRInt8 int8;^M
#endif^M
^M
typedef PRFloat64 float64;^M
typedef PRUptrdiff uptrdiff_t;^M
typedef PRUword uprword_t;^M
typedef PRWord prword_t;^M
^M
^M
/* Re: prbit.h */^M
#define TEST_BIT	PR_TEST_BIT^M
#define SET_BIT		PR_SET_BIT^M
#define CLEAR_BIT	PR_CLEAR_BIT^M
^M
/* Re: prarena.h->plarena.h */^M
#define PRArena PLArena^M
#define PRArenaPool PLArenaPool^M
#define PRArenaStats PLArenaStats^M
#define PR_ARENA_ALIGN PL_ARENA_ALIGN^M
#define PR_INIT_ARENA_POOL PL_INIT_ARENA_POOL^M
#define PR_ARENA_ALLOCATE PL_ARENA_ALLOCATE^M
#define PR_ARENA_GROW PL_ARENA_GROW^M
#define PR_ARENA_MARK PL_ARENA_MARK^M
#define PR_CLEAR_UNUSED PL_CLEAR_UNUSED^M
#define PR_CLEAR_ARENA PL_CLEAR_ARENA^M
#define PR_ARENA_RELEASE PL_ARENA_RELEASE^M
#define PR_COUNT_ARENA PL_COUNT_ARENA^M
#define PR_ARENA_DESTROY PL_ARENA_DESTROY^M
#define PR_InitArenaPool PL_InitArenaPool^M
#define PR_FreeArenaPool PL_FreeArenaPool^M
#define PR_FinishArenaPool PL_FinishArenaPool^M
#define PR_CompactArenaPool PL_CompactArenaPool^M
#define PR_ArenaFinish PL_ArenaFinish^M
#define PR_ArenaAllocate PL_ArenaAllocate^M
#define PR_ArenaGrow PL_ArenaGrow^M
#define PR_ArenaRelease PL_ArenaRelease^M
#define PR_ArenaCountAllocation PL_ArenaCountAllocation^M
#define PR_ArenaCountInplaceGrowth PL_ArenaCountInplaceGrowth^M
#define PR_ArenaCountGrowth PL_ArenaCountGrowth^M
#define PR_ArenaCountRelease PL_ArenaCountRelease^M
#define PR_ArenaCountRetract PL_ArenaCountRetract^M
^M
/* Re: prhash.h->plhash.h */^M
#define PRHashEntry PLHashEntry^M
#define PRHashTable PLHashTable^M
#define PRHashNumber PLHashNumber^M
#define PRHashFunction PLHashFunction^M
#define PRHashComparator PLHashComparator^M
#define PRHashEnumerator PLHashEnumerator^M
#define PRHashAllocOps PLHashAllocOps^M
#define PR_NewHashTable PL_NewHashTable^M
#define PR_HashTableDestroy PL_HashTableDestroy^M
#define PR_HashTableRawLookup PL_HashTableRawLookup^M
#define PR_HashTableRawAdd PL_HashTableRawAdd^M
#define PR_HashTableRawRemove PL_HashTableRawRemove^M
#define PR_HashTableAdd PL_HashTableAdd^M
#define PR_HashTableRemove PL_HashTableRemove^M
#define PR_HashTableEnumerateEntries PL_HashTableEnumerateEntries^M
#define PR_HashTableLookup PL_HashTableLookup^M
#define PR_HashTableDump PL_HashTableDump^M
#define PR_HashString PL_HashString^M
#define PR_CompareStrings PL_CompareStrings^M
#define PR_CompareValues PL_CompareValues^M
^M
#if defined(XP_MAC)^M
#ifndef TRUE				/* Mac standard is lower case true */^M
	#define TRUE 1^M
#endif^M
#ifndef FALSE				/* Mac standard is lower case false */^M
	#define FALSE 0^M
#endif^M
#endif^M
^M
#endif /* !defined(PROTYPES_H) */^M
