/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prclist_h___^M
#define prclist_h___^M
^M
#include "prtypes.h"^M
^M
typedef struct PRCListStr PRCList;^M
^M
/*^M
** Circular linked list^M
*/^M
struct PRCListStr {^M
    PRCList	*next;^M
    PRCList	*prev;^M
};^M
^M
/*^M
** Insert element "_e" into the list, before "_l".^M
*/^M
#define PR_INSERT_BEFORE(_e,_l)	 \^M
    PR_BEGIN_MACRO		 \^M
	(_e)->next = (_l);	 \^M
	(_e)->prev = (_l)->prev; \^M
	(_l)->prev->next = (_e); \^M
	(_l)->prev = (_e);	 \^M
    PR_END_MACRO^M
^M
/*^M
** Insert element "_e" into the list, after "_l".^M
*/^M
#define PR_INSERT_AFTER(_e,_l)	 \^M
    PR_BEGIN_MACRO		 \^M
	(_e)->next = (_l)->next; \^M
	(_e)->prev = (_l);	 \^M
	(_l)->next->prev = (_e); \^M
	(_l)->next = (_e);	 \^M
    PR_END_MACRO^M
^M
/*^M
** Return the element following element "_e"^M
*/^M
#define PR_NEXT_LINK(_e)	 \^M
    	((_e)->next)^M
/*^M
** Return the element preceding element "_e"^M
*/^M
#define PR_PREV_LINK(_e)	 \^M
    	((_e)->prev)^M
^M
/*^M
** Append an element "_e" to the end of the list "_l"^M
*/^M
#define PR_APPEND_LINK(_e,_l) PR_INSERT_BEFORE(_e,_l)^M
^M
/*^M
** Insert an element "_e" at the head of the list "_l"^M
*/^M
#define PR_INSERT_LINK(_e,_l) PR_INSERT_AFTER(_e,_l)^M
^M
/* Return the head/tail of the list */^M
#define PR_LIST_HEAD(_l) (_l)->next^M
#define PR_LIST_TAIL(_l) (_l)->prev^M
^M
/*^M
** Remove the element "_e" from it's circular list.^M
*/^M
#define PR_REMOVE_LINK(_e)	       \^M
    PR_BEGIN_MACRO		       \^M
	(_e)->prev->next = (_e)->next; \^M
	(_e)->next->prev = (_e)->prev; \^M
    PR_END_MACRO^M
^M
/*^M
** Remove the element "_e" from it's circular list. Also initializes the^M
** linkage.^M
*/^M
#define PR_REMOVE_AND_INIT_LINK(_e)    \^M
    PR_BEGIN_MACRO		       \^M
	(_e)->prev->next = (_e)->next; \^M
	(_e)->next->prev = (_e)->prev; \^M
	(_e)->next = (_e);	       \^M
	(_e)->prev = (_e);	       \^M
    PR_END_MACRO^M
^M
/*^M
** Return non-zero if the given circular list "_l" is empty, zero if the^M
** circular list is not empty^M
*/^M
#define PR_CLIST_IS_EMPTY(_l) \^M
    ((_l)->next == (_l))^M
^M
/*^M
** Initialize a circular list^M
*/^M
#define PR_INIT_CLIST(_l)  \^M
    PR_BEGIN_MACRO	   \^M
	(_l)->next = (_l); \^M
	(_l)->prev = (_l); \^M
    PR_END_MACRO^M
^M
#define PR_INIT_STATIC_CLIST(_l) \^M
    {(_l), (_l)}^M
^M
#endif /* prclist_h___ */^M
