/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prdtoa_h___^M
#define prdtoa_h___^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
** PR_strtod() returns as a double-precision floating-point number^M
** the  value represented by the character string pointed to by^M
** s00. The string is scanned up to the first unrecognized^M
** character.^M
**a^M
** If the value of se is not (char **)NULL, a  pointer  to^M
** the  character terminating the scan is returned in the location pointed^M
** to by se. If no number can be formed, se is set to s00, and^M
** zero is returned.^M
*/^M
#if defined(HAVE_WATCOM_BUG_1)^M
/* this is a hack to circumvent a bug in the Watcom C/C++ 11.0 compiler^M
** When Watcom fixes the bug, remove the special case for Win16^M
*/^M
PRFloat64 __pascal __loadds __export^M
#else^M
NSPR_API(PRFloat64)^M
#endif^M
PR_strtod(const char *s00, char **se);^M
^M
/*^M
** PR_cnvtf()^M
** conversion routines for floating point^M
** prcsn - number of digits of precision to generate floating^M
** point value.^M
*/^M
NSPR_API(void) PR_cnvtf(char *buf, PRIntn bufsz, PRIntn prcsn, PRFloat64 fval);^M
^M
/*^M
** PR_dtoa() converts double to a string.^M
**^M
** ARGUMENTS:^M
** If rve is not null, *rve is set to point to the end of the return value.^M
** If d is +-Infinity or NaN, then *decpt is set to 9999.^M
**^M
** mode:^M
**     0 ==> shortest string that yields d when read in^M
**           and rounded to nearest.^M
*/^M
NSPR_API(PRStatus) PR_dtoa(PRFloat64 d, PRIntn mode, PRIntn ndigits,^M
	PRIntn *decpt, PRIntn *sign, char **rve, char *buf, PRSize bufsize);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prdtoa_h___ */^M
