/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prerror_h___^M
#define prerror_h___^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
typedef PRInt32 PRErrorCode;^M
^M
#define PR_NSPR_ERROR_BASE -6000^M
^M
#include "prerr.h"^M
^M
/*^M
** Set error will preserve an error condition within a thread context.^M
** The values stored are the NSPR (platform independent) translation of^M
** the error. Also, if available, the platform specific oserror is stored.^M
** If there is no appropriate OS error number, a zero my be supplied.^M
*/^M
NSPR_API(void) PR_SetError(PRErrorCode errorCode, PRInt32 oserr);^M
^M
/*^M
** The text value specified may be NULL. If it is not NULL and the text length^M
** is zero, the string is assumed to be a null terminated C string. Otherwise^M
** the text is assumed to be the length specified and possibly include NULL^M
** characters (e.g., a multi-national string).^M
**^M
** The text will be copied into to thread structure and remain there^M
** until the next call to PR_SetError.^M
*/^M
NSPR_API(void) PR_SetErrorText(^M
    PRIntn textLength, const char *text);^M
^M
/*^M
** Return the current threads last set error code.^M
*/^M
NSPR_API(PRErrorCode) PR_GetError(void);^M
^M
/*^M
** Return the current threads last set os error code. This is used for^M
** machine specific code that desires the underlying os error.^M
*/^M
NSPR_API(PRInt32) PR_GetOSError(void);^M
^M
/*^M
** Get the length of the error text. If a zero is returned, then there^M
** is no text. Otherwise, the value returned is sufficient to contain^M
** the error text currently available.^M
*/^M
NSPR_API(PRInt32) PR_GetErrorTextLength(void);^M
^M
/*^M
** Copy the current threads current error text. Then actual number of bytes^M
** copied is returned as the result. If the result is zero, the 'text' area^M
** is unaffected.^M
*/^M
NSPR_API(PRInt32) PR_GetErrorText(char *text);^M
^M
^M
/*^M
Copyright (C) 1987, 1988 Student Information Processing Board of the^M
Massachusetts Institute of Technology.^M
^M
Permission to use, copy, modify, and distribute this software and its^M
documentation for any purpose and without fee is hereby granted, provided^M
that the above copyright notice appear in all copies and that both that^M
copyright notice and this permission notice appear in supporting^M
documentation, and that the names of M.I.T. and the M.I.T. S.I.P.B. not be^M
used in advertising or publicity pertaining to distribution of the software^M
without specific, written prior permission.  M.I.T. and the M.I.T. S.I.P.B.^M
make no representations about the suitability of this software for any^M
purpose.  It is provided "as is" without express or implied warranty.^M
*/^M
^M
^M
/*^M
 * NOTE:^M
 *		The interfaces for error-code-translation described in the rest of^M
 *		this file are preliminary in the 3.1 release of nspr and are subject ^M
 *		to change in future releases.^M
 */^M
^M
/*^M
** Description:	Localizable error code to string function.^M
**^M
**^M
** NSPR provides a mechanism for converting an error code to a^M
** descriptive string, in a caller-specified language.^M
**^M
** Error codes themselves are 32 bit (signed) integers.  Typically,^M
** the high order 24 bits are an identifier of which error table the^M
** error code is from, and the low order 8 bits are a sequential error^M
** number within the table.  NSPR supports error tables whose first^M
** error code is not a multiple of 256, such error code assignments^M
** should be avoided when possible.^M
**^M
** Error table 0 is defined to match the UNIX system call error table^M
** (sys_errlist); this allows errno values to be used directly in the^M
** library.  Other error table numbers are typically formed by^M
** compacting together the first four characters of the error table^M
** name.  The mapping between characters in the name and numeric^M
** values in the error code are defined in a system-independent^M
** fashion, so that two systems that can pass integral values between^M
** them can reliably pass error codes without loss of meaning; this^M
** should work even if the character sets used are not the^M
** same. (However, if this is to be done, error table 0 should be^M
** avoided, since the local system call error tables may differ.)^M
**^M
** Libraries defining error codes need only provide a table mapping^M
** error code numbers to names and default English descriptions,^M
** calling a routine to install the table, making it ``known'' to NSPR^M
** library.  Once installed, a table may not be removed.  Any error^M
** code the library generates can be converted to the corresponding^M
** error message.  There is also a default format for error codes^M
** accidentally returned before making the table known, which is of^M
** the form "unknown code foo 32", where "foo" would be the name of^M
** the table.^M
**^M
** Normally, the error code conversion routine only supports the^M
** languages "i-default" and "en", returning the error-table-provided^M
** English description for both languages.  The application may^M
** provide a localization plugin, allowing support for additional^M
** languages.^M
**^M
**/^M
^M
/**********************************************************************/^M
/************************* TYPES AND CONSTANTS ************************/^M
/**********************************************************************/^M
^M
/*^M
 * PRLanguageCode --^M
 *^M
 *    NSPR represents a language code as a non-negative integer.^M
 *    Languages 0 is always "i-default" the language you get without^M
 *    explicit negotiation.  Language 1 is always "en", English^M
 *    which has been explicitly negotiated.  Additional language^M
 *    codes are defined by an application-provided localization plugin.^M
 */^M
typedef PRUint32 PRLanguageCode;^M
#define PR_LANGUAGE_I_DEFAULT 0 /* i-default, the default language */^M
#define PR_LANGUAGE_EN 1 /* English, explicitly negotiated */^M
^M
/*^M
 * struct PRErrorMessage --^M
 *^M
 *    An error message in an error table.^M
 */^M
struct PRErrorMessage {^M
    const char * name;    /* Macro name for error */^M
    const char * en_text; /* Default English text */^M
};^M
^M
/*^M
 * struct PRErrorTable --^M
 *^M
 *    An error table, provided by a library.^M
 */^M
struct PRErrorTable {^M
    const struct PRErrorMessage * msgs; /* Array of error information */^M
    const char *name; /* Name of error table source */^M
    PRErrorCode base; /* Error code for first error in table */^M
    int n_msgs; /* Number of codes in table */^M
};^M
^M
/*^M
 * struct PRErrorCallbackPrivate --^M
 *^M
 *    A private structure for the localization plugin ^M
 */^M
struct PRErrorCallbackPrivate;^M
^M
/*^M
 * struct PRErrorCallbackTablePrivate --^M
 *^M
 *    A data structure under which the localization plugin may store information,^M
 *    associated with an error table, that is private to itself.^M
 */^M
struct PRErrorCallbackTablePrivate;^M
^M
/*^M
 * PRErrorCallbackLookupFn --^M
 *^M
 *    A function of PRErrorCallbackLookupFn type is a localization^M
 *    plugin callback which converts an error code into a description^M
 *    in the requested language.  The callback is provided the^M
 *    appropriate error table, private data for the plugin and the table.^M
 *    The callback returns the appropriate UTF-8 encoded description, or NULL^M
 *    if no description can be found.^M
 */^M
typedef const char *^M
PRErrorCallbackLookupFn(PRErrorCode code, PRLanguageCode language, ^M
		   const struct PRErrorTable *table,^M
		   struct PRErrorCallbackPrivate *cb_private,^M
		   struct PRErrorCallbackTablePrivate *table_private);^M
^M
/*^M
 * PRErrorCallbackNewTableFn --^M
 *^M
 *    A function PRErrorCallbackNewTableFn type is a localization plugin^M
 *    callback which is called once with each error table registered^M
 *    with NSPR.  The callback is provided with the error table and^M
 *    the plugin's private structure.  The callback returns any table private^M
 *    data it wishes to associate with the error table.  Does not need to be thread^M
 *    safe.^M
 */^M
typedef struct PRErrorCallbackTablePrivate *^M
PRErrorCallbackNewTableFn(const struct PRErrorTable *table,^M
			struct PRErrorCallbackPrivate *cb_private);^M
^M
/**********************************************************************/^M
/****************************** FUNCTIONS *****************************/^M
/**********************************************************************/^M
^M
/***********************************************************************^M
** FUNCTION:    PR_ErrorToString^M
** DESCRIPTION:^M
**  Returns the UTF-8 message for an error code in^M
**  the requested language.  May return the message^M
**  in the default language if a translation in the requested^M
**  language is not available.  The returned string is^M
**  valid for the duration of the process.  Never returns NULL.^M
**^M
***********************************************************************/^M
NSPR_API(const char *) PR_ErrorToString(PRErrorCode code,^M
    PRLanguageCode language);^M
^M
^M
/***********************************************************************^M
** FUNCTION:    PR_ErrorToName^M
** DESCRIPTION:^M
**  Returns the macro name for an error code, or NULL^M
**  if the error code is not known.  The returned string is^M
**  valid for the duration of the process.^M
**^M
**  Does not work for error table 0, the system error codes.^M
**^M
***********************************************************************/^M
NSPR_API(const char *) PR_ErrorToName(PRErrorCode code);^M
^M
^M
/***********************************************************************^M
** FUNCTION:    PR_ErrorLanguages^M
** DESCRIPTION:^M
**  Returns the RFC 1766 language tags for the language^M
**  codes PR_ErrorToString() supports.  The returned array is valid^M
**  for the duration of the process.  Never returns NULL.  The first^M
**  item in the returned array is the language tag for PRLanguageCode 0,^M
**  the second is for PRLanguageCode 1, and so on.  The array is terminated^M
**  with a null pointer.^M
**^M
***********************************************************************/^M
NSPR_API(const char * const *) PR_ErrorLanguages(void);^M
^M
^M
/***********************************************************************^M
** FUNCTION:    PR_ErrorInstallTable^M
** DESCRIPTION:^M
**  Registers an error table with NSPR.  Must be done exactly once per^M
**  table.  Memory pointed to by `table' must remain valid for the life^M
**  of the process.^M
**^M
**  NOT THREAD SAFE!^M
**  ^M
***********************************************************************/^M
NSPR_API(PRErrorCode) PR_ErrorInstallTable(const struct PRErrorTable *table);^M
^M
^M
/***********************************************************************^M
** FUNCTION:    PR_ErrorInstallCallback^M
** DESCRIPTION:^M
**  Registers an error localization plugin with NSPR.  May be called^M
**  at most one time.  `languages' contains the language codes supported^M
**  by this plugin.  Languages 0 and 1 must be "i-default" and "en"^M
**  respectively.  `lookup' and `newtable' contain pointers to^M
**  the plugin callback functions.  `cb_private' contains any information^M
**  private to the plugin functions.^M
**^M
**  NOT THREAD SAFE!^M
**^M
***********************************************************************/^M
NSPR_API(void) PR_ErrorInstallCallback(const char * const * languages,^M
			      PRErrorCallbackLookupFn *lookup, ^M
			      PRErrorCallbackNewTableFn *newtable,^M
			      struct PRErrorCallbackPrivate *cb_private);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prerror_h___ */^M
