/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
 * File:		prinet.h^M
 * Description:^M
 *     Header file used to find the system header files for socket support.^M
 *     This file serves the following purposes:^M
 *     - A cross-platform, "get-everything" socket header file.  On^M
 *       Unix, socket support is scattered in several header files,^M
 *       while Windows and Mac have a "get-everything" socket header^M
 *       file.^M
 *     - NSPR needs the following macro definitions and function^M
 *       prototype declarations from these header files:^M
 *           AF_INET^M
 *           INADDR_ANY, INADDR_LOOPBACK, INADDR_BROADCAST^M
 *           ntohl(), ntohs(), htonl(), ntons().^M
 *       NSPR does not define its own versions of these macros and^M
 *       functions.  It simply uses the native versions, which have^M
 *       the same names on all supported platforms.^M
 *     This file is intended to be included by nspr20 public header^M
 *     files, such as prio.h.  One should not include this file directly.^M
 */^M
^M
#ifndef prinet_h__^M
#define prinet_h__^M
^M
#if defined(XP_UNIX) || defined(XP_OS2) || defined(XP_BEOS)^M
#ifdef linux^M
#undef __STRICT_ANSI__^M
#define __STRICT_ANSI__^M
#endif^M
#include <sys/types.h>^M
#include <sys/socket.h>		/* AF_INET */^M
#include <netinet/in.h>         /* INADDR_ANY, ..., ntohl(), ... */^M
#ifdef XP_OS2^M
#include <sys/ioctl.h>^M
#endif^M
#ifdef XP_UNIX^M
#ifdef AIX^M
/*^M
 * On AIX 4.3, the header <arpa/inet.h> refers to struct^M
 * ether_addr and struct sockaddr_dl that are not declared.^M
 * The following struct declarations eliminate the compiler^M
 * warnings.^M
 */^M
struct ether_addr;^M
struct sockaddr_dl;^M
#endif /* AIX */^M
#include <arpa/inet.h>^M
#endif /* XP_UNIX */^M
#include <netdb.h>^M
^M
#if defined(FREEBSD) || defined(BSDI) || defined(QNX)^M
#include <rpc/types.h> /* the only place that defines INADDR_LOOPBACK */^M
#endif^M
^M
/*^M
 * OS/2 hack.  For some reason INADDR_LOOPBACK is not defined in the^M
 * socket headers.^M
 */^M
#if defined(OS2) && !defined(INADDR_LOOPBACK)^M
#define INADDR_LOOPBACK gethostid()^M
#endif^M
^M
/*^M
 * Prototypes of ntohl() etc. are declared in <machine/endian.h>^M
 * on these platforms.^M
 */^M
#if defined(BSDI) || defined(OSF1)^M
#include <machine/endian.h>^M
#endif^M
^M
#elif defined(WIN32)^M
^M
/* Do not include any system header files. */^M
^M
#elif defined(WIN16)^M
^M
#include <winsock.h>^M
^M
#elif defined(XP_MAC)^M
^M
#include "macsocket.h"^M
^M
#else^M
^M
#error Unknown platform^M
^M
#endif^M
^M
#endif /* prinet_h__ */^M
