/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prinit_h___^M
#define prinit_h___^M
^M
#include "prthread.h"^M
#include "prtypes.h"^M
#include "prwin16.h"^M
#include <stdio.h>^M
^M
PR_BEGIN_EXTERN_C^M
^M
/************************************************************************/^M
/**************************IDENTITY AND VERSIONING***********************/^M
/************************************************************************/^M
^M
/*^M
** NSPR's name, this should persist until at least the turn of the^M
** century.^M
*/^M
#define PR_NAME     "NSPR"^M
^M
/*^M
** NSPR's version is used to determine the likelihood that the version you^M
** used to build your component is anywhere close to being compatible with^M
** what is in the underlying library.^M
**^M
** The format of the version string is^M
**     "<major version>.<minor version>[.<patch level>] [<Beta>]"^M
*/^M
#define PR_VERSION  "4.1.1"^M
#define PR_VMAJOR   4^M
#define PR_VMINOR   1^M
#define PR_VPATCH   1^M
#define PR_BETA     PR_FALSE^M
^M
/*^M
** PRVersionCheck^M
**^M
** The basic signature of the function that is called to provide version^M
** checking. The result will be a boolean that indicates the likelihood^M
** that the underling library will perform as the caller expects.^M
**^M
** The only argument is a string, which should be the verson identifier^M
** of the library in question. That string will be compared against an^M
** equivalent string that represents the actual build version of the^M
** exporting library.^M
**^M
** The result will be the logical union of the directly called library^M
** and all dependent libraries.^M
*/^M
^M
typedef PRBool (*PRVersionCheck)(const char*);^M
^M
/*^M
** PR_VersionCheck^M
**^M
** NSPR's existance proof of the version check function.^M
**^M
** Note that NSPR has no cooperating dependencies.^M
*/^M
^M
NSPR_API(PRBool) PR_VersionCheck(const char *importedVersion);^M
^M
^M
/************************************************************************/^M
/*******************************INITIALIZATION***************************/^M
/************************************************************************/^M
^M
/*^M
** Initialize the runtime. Attach a thread object to the currently^M
** executing native thread of type "type".^M
**^M
** The specificaiton of 'maxPTDs' is ignored.^M
*/^M
NSPR_API(void) PR_Init(^M
    PRThreadType type, PRThreadPriority priority, PRUintn maxPTDs);^M
^M
/*^M
** And alternate form of initialization, one that may become the default if^M
** not the only mechanism, provides a method to get the NSPR runtime init-^M
** ialized and place NSPR between the caller and the runtime library. This^M
** allows main() to be treated as any other thread root function, signalling^M
** its compeletion by returning and allowing the runtime to coordinate the^M
** completion of the other threads of the runtime.^M
**^M
** The priority of the main (or primordial) thread will be PR_PRIORITY_NORMAL.^M
** The thread may adjust its own priority by using PR_SetPriority(), though^M
** at this time the support for priorities is somewhat weak.^M
**^M
** The specificaiton of 'maxPTDs' is ignored.^M
**^M
** The value returned by PR_Initialize is the value returned from the root^M
** function, 'prmain'.^M
*/^M
^M
typedef PRIntn (PR_CALLBACK *PRPrimordialFn)(PRIntn argc, char **argv);^M
^M
NSPR_API(PRIntn) PR_Initialize(^M
    PRPrimordialFn prmain, PRIntn argc, char **argv, PRUintn maxPTDs);^M
^M
/*^M
** Return PR_TRUE if PR_Init has already been called.^M
*/^M
NSPR_API(PRBool) PR_Initialized(void);^M
^M
/*^M
 * Perform a graceful shutdown of NSPR.  PR_Cleanup() may be called by^M
 * the primordial thread near the end of the main() function.^M
 *^M
 * PR_Cleanup() attempts to synchronize the natural termination of^M
 * process.  It does that by blocking the caller, if and only if it is^M
 * the primordial thread, until the number of user threads has dropped^M
 * to zero.  When the primordial thread returns from main(), the process^M
 * will immediately and silently exit.  That is, it will (if necessary)^M
 * forcibly terminate any existing threads and exit without significant^M
 * blocking and there will be no error messages or core files.^M
 *^M
 * PR_Cleanup() returns PR_SUCCESS if NSPR is successfully shutdown,^M
 * or PR_FAILURE if the calling thread of this function is not the^M
 * primordial thread.^M
 */^M
NSPR_API(PRStatus) PR_Cleanup(void);^M
^M
/*^M
** Disable Interrupts^M
**		Disables timer signals used for pre-emptive scheduling.^M
*/^M
NSPR_API(void) PR_DisableClockInterrupts(void);^M
^M
/*^M
** Enables Interrupts^M
**		Enables timer signals used for pre-emptive scheduling.^M
*/^M
NSPR_API(void) PR_EnableClockInterrupts(void);^M
^M
/*^M
** Block Interrupts^M
**		Blocks the timer signal used for pre-emptive scheduling^M
*/^M
NSPR_API(void) PR_BlockClockInterrupts(void);^M
^M
/*^M
** Unblock Interrupts^M
**		Unblocks the timer signal used for pre-emptive scheduling^M
*/^M
NSPR_API(void) PR_UnblockClockInterrupts(void);^M
^M
/*^M
** Create extra virtual processor threads. Generally used with MP systems.^M
*/^M
NSPR_API(void) PR_SetConcurrency(PRUintn numCPUs);^M
^M
/*^M
** Control the method and size of the file descriptor (PRFileDesc*)^M
** cache used by the runtime. Setting 'high' to zero is for performance,^M
** any other value probably for debugging (see memo on FD caching).^M
*/^M
NSPR_API(PRStatus) PR_SetFDCacheSize(PRIntn low, PRIntn high);^M
^M
/*^M
 * Cause an immediate, nongraceful, forced termination of the process.^M
 * It takes a PRIntn argument, which is the exit status code of the^M
 * process.^M
 */^M
NSPR_API(void) PR_ProcessExit(PRIntn status);^M
^M
/*^M
** Abort the process in a non-graceful manner. This will cause a core file,^M
** call to the debugger or other moral equivalent as well as causing the^M
** entire process to stop.^M
*/^M
NSPR_API(void) PR_Abort(void);^M
^M
/*^M
 ****************************************************************^M
 *^M
 * Module initialization:^M
 *^M
 ****************************************************************^M
 */^M
^M
typedef struct PRCallOnceType {^M
    PRIntn initialized;^M
    PRInt32 inProgress;^M
    PRStatus status;^M
} PRCallOnceType;^M
^M
typedef PRStatus (PR_CALLBACK *PRCallOnceFN)(void);^M
^M
NSPR_API(PRStatus) PR_CallOnce(^M
    PRCallOnceType *once,^M
    PRCallOnceFN    func^M
);^M
^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prinit_h___ */^M
