/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prproces_h___^M
#define prproces_h___^M
^M
#include "prtypes.h"^M
#include "prio.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/************************************************************************/^M
/*****************************PROCESS OPERATIONS*************************/^M
/************************************************************************/^M
^M
typedef struct PRProcess PRProcess;^M
typedef struct PRProcessAttr PRProcessAttr;^M
^M
NSPR_API(PRProcessAttr *) PR_NewProcessAttr(void);^M
^M
NSPR_API(void) PR_ResetProcessAttr(PRProcessAttr *attr);^M
^M
NSPR_API(void) PR_DestroyProcessAttr(PRProcessAttr *attr);^M
^M
NSPR_API(void) PR_ProcessAttrSetStdioRedirect(^M
    PRProcessAttr *attr,^M
    PRSpecialFD stdioFd,^M
    PRFileDesc *redirectFd^M
);^M
^M
/*^M
 * OBSOLETE -- use PR_ProcessAttrSetStdioRedirect instead.^M
 */^M
NSPR_API(void) PR_SetStdioRedirect(^M
    PRProcessAttr *attr,^M
    PRSpecialFD stdioFd,^M
    PRFileDesc *redirectFd^M
);^M
^M
NSPR_API(PRStatus) PR_ProcessAttrSetCurrentDirectory(^M
    PRProcessAttr *attr,^M
    const char *dir^M
);^M
^M
NSPR_API(PRStatus) PR_ProcessAttrSetInheritableFD(^M
    PRProcessAttr *attr,^M
    PRFileDesc *fd,^M
    const char *name^M
);^M
^M
/*^M
** Create a new process^M
**^M
** Create a new process executing the file specified as 'path' and with^M
** the supplied arguments and environment.^M
**^M
** This function may fail because of illegal access (permissions),^M
** invalid arguments or insufficient resources.^M
**^M
** A process may be created such that the creator can later synchronize its^M
** termination using PR_WaitProcess(). ^M
*/^M
^M
NSPR_API(PRProcess*) PR_CreateProcess(^M
    const char *path,^M
    char *const *argv,^M
    char *const *envp,^M
    const PRProcessAttr *attr);^M
^M
NSPR_API(PRStatus) PR_CreateProcessDetached(^M
    const char *path,^M
    char *const *argv,^M
    char *const *envp,^M
    const PRProcessAttr *attr);^M
^M
NSPR_API(PRStatus) PR_DetachProcess(PRProcess *process);^M
^M
NSPR_API(PRStatus) PR_WaitProcess(PRProcess *process, PRInt32 *exitCode);^M
^M
NSPR_API(PRStatus) PR_KillProcess(PRProcess *process);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prproces_h___ */^M
