/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1999-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prtpool_h___^M
#define prtpool_h___^M
^M
#include "prtypes.h"^M
#include "prthread.h"^M
#include "prio.h"^M
#include "prerror.h"^M
^M
/*^M
 * NOTE:^M
 *		THIS API IS A PRELIMINARY VERSION IN NSPR 4.0 AND IS SUBJECT TO^M
 *		CHANGE^M
 */^M
^M
PR_BEGIN_EXTERN_C^M
^M
typedef struct PRJobIoDesc {^M
    PRFileDesc *socket;^M
    PRErrorCode error;^M
    PRIntervalTime timeout;^M
} PRJobIoDesc;^M
^M
typedef struct PRThreadPool PRThreadPool;^M
typedef struct PRJob PRJob;^M
typedef void (PR_CALLBACK *PRJobFn) (void *arg);^M
^M
/* Create thread pool */^M
NSPR_API(PRThreadPool *)^M
PR_CreateThreadPool(PRInt32 initial_threads, PRInt32 max_threads,^M
                          PRUint32 stacksize);^M
^M
/* queue a job */^M
NSPR_API(PRJob *)^M
PR_QueueJob(PRThreadPool *tpool, PRJobFn fn, void *arg, PRBool joinable);^M
^M
/* queue a job, when a socket is readable */^M
NSPR_API(PRJob *)^M
PR_QueueJob_Read(PRThreadPool *tpool, PRJobIoDesc *iod,^M
							PRJobFn fn, void * arg, PRBool joinable);^M
^M
/* queue a job, when a socket is writeable */^M
NSPR_API(PRJob *)^M
PR_QueueJob_Write(PRThreadPool *tpool, PRJobIoDesc *iod,^M
								PRJobFn fn, void * arg, PRBool joinable);^M
^M
/* queue a job, when a socket has a pending connection */^M
NSPR_API(PRJob *)^M
PR_QueueJob_Accept(PRThreadPool *tpool, PRJobIoDesc *iod,^M
									PRJobFn fn, void * arg, PRBool joinable);^M
^M
/* queue a job, when the socket connection to addr succeeds or fails */^M
NSPR_API(PRJob *)^M
PR_QueueJob_Connect(PRThreadPool *tpool, PRJobIoDesc *iod,^M
			const PRNetAddr *addr, PRJobFn fn, void * arg, PRBool joinable);^M
^M
/* queue a job, when a timer exipres */^M
NSPR_API(PRJob *)^M
PR_QueueJob_Timer(PRThreadPool *tpool, PRIntervalTime timeout,^M
								PRJobFn fn, void * arg, PRBool joinable);^M
/* cancel a job */^M
NSPR_API(PRStatus)^M
PR_CancelJob(PRJob *job);^M
^M
/* join a job */^M
NSPR_API(PRStatus)^M
PR_JoinJob(PRJob *job);^M
^M
/* shutdown pool */^M
NSPR_API(PRStatus)^M
PR_ShutdownThreadPool(PRThreadPool *tpool);^M
^M
/* join pool, wait for exit of all threads */^M
NSPR_API(PRStatus)^M
PR_JoinThreadPool(PRThreadPool *tpool);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prtpool_h___ */^M
